/*********************************************************************
 *                
 * Copyright (C) 2002,  Karlsruhe University
 *                
 * File path:     pistachio/user/lib/l4/syscalls.c
 * Description:   syscall gate relocation
 *                
 * @LICENSE@
 *                
 * $Id: x86-syscalls.c,v 1.2 2003/04/08 14:00:28 haeber Exp $
 *                
 ********************************************************************/

#include <l4/types.h>
#include <l4/kip.h>

#define DEFINE_SYSCALL(syscall)				\
void (*__L4_##syscall)(void);				\
void __LibL4_Init_##syscall(void);			\
asm ("__LibL4_Init_"#syscall":\n"			\
     "pusha\n"						\
     "call __LibL4_Init\n"				\
     "popa\n"						\
     "jmp *__L4_"#syscall);				\
void (*__L4_##syscall)(void) = __LibL4_Init_##syscall;


DEFINE_SYSCALL(Ipc)
DEFINE_SYSCALL(Lipc)
DEFINE_SYSCALL(ExchangeRegisters)
DEFINE_SYSCALL(ThreadControl)
DEFINE_SYSCALL(SystemClock)
DEFINE_SYSCALL(ThreadSwitch)
DEFINE_SYSCALL(Schedule)
DEFINE_SYSCALL(Unmap)
DEFINE_SYSCALL(SpaceControl)
DEFINE_SYSCALL(ProcessorControl)
DEFINE_SYSCALL(MemoryControl)

#define SET_SYSCALL(syscall) __L4_##syscall = (void(*)(void))((L4_Word_t)kip + kip->syscall)

void __LibL4_Init(void)
{
    L4_Word_t dummy;
    L4_KernelInterfacePage_t * kip = (L4_KernelInterfacePage_t*)
	L4_KernelInterface(&dummy, &dummy, &dummy);

    SET_SYSCALL(SpaceControl);
    SET_SYSCALL(ThreadControl);
    SET_SYSCALL(ProcessorControl);
    SET_SYSCALL(MemoryControl);

    SET_SYSCALL(Ipc);
    SET_SYSCALL(Lipc);
    SET_SYSCALL(Unmap);
    SET_SYSCALL(ExchangeRegisters);

    SET_SYSCALL(SystemClock);
    SET_SYSCALL(ThreadSwitch);
    SET_SYSCALL(Schedule);
}


